#ifndef BALLTEST_H
#define BALLTEST_H


/**
 * \brief Check that Ball object retains initial position and area.
 * 
 * \returns true if all the tests passed
 */

bool Ball_test_movement()
{
    Ball _ball;
    _ball.init(8, 5, 2, FILL_BLACK);

    // Set the position to 8, 5
    Vector2D initial_pos = {8, 5};
    _ball.setPosition(initial_pos);

    // Read the position
    Vector2D read_pos_1 = _ball.getPosition();
    printf("%f, %f\n", read_pos_1.x, read_pos_1.y);
    

    // ReRead the position
    Vector2D read_pos_2 = _ball.getPosition();
    printf("%f, %f\n", read_pos_2.x, read_pos_2.y);
    
    // Now check that both the positions are as expected
    bool success_flag = true;
    
    // Fail the test if the initial position is wrong
    if (read_pos_1.x != 8 || read_pos_1.y != 5) {
        success_flag = false;
    }
    
    // Fail the test if the 2nd position check is wrong
    if (read_pos_2.x != 8 || read_pos_2.y != 5) {
        success_flag = false;
    }

    return success_flag;
}
#endif