#include "Menu.h"





const int run[12][10] =   {
    { 0,0,0,0,0,1,1,1,0,0 },
    { 0,0,0,0,0,1,1,1,0,0 },
    { 0,0,0,1,1,1,1,0,0,0 },
    { 0,0,1,1,1,1,0,1,0,0 },
    { 0,1,1,0,1,1,0,1,1,1 },
    { 1,0,0,0,1,1,0,0,0,0 },
    { 0,0,0,1,1,1,1,0,0,0 },
    { 0,0,1,1,0,0,1,1,0,0 },
    { 1,1,1,1,0,0,0,1,1,0 },
    { 0,0,0,0,0,0,1,1,0,0 },
    { 0,0,0,0,0,1,1,0,0,0 },
    { 0,0,0,0,1,1,0,0,0,0 },
};

const int run1[11][9] =   {
    { 0,0,0,0,0,1,1,1,0 },
    { 0,0,0,0,0,1,1,1,0 },
    { 0,0,0,1,1,1,1,0,0 },
    { 0,0,1,1,1,1,0,1,0 },
    { 0,1,1,0,1,1,0,1,1 },
    { 1,0,0,0,1,1,0,0,0 },
    { 0,0,0,1,1,1,1,0,0 },
    { 0,0,1,1,0,0,1,1,0 },
    { 1,1,1,1,0,0,0,1,1 },
    { 0,0,0,0,0,0,1,1,0 },
    { 0,0,0,0,0,1,1,0,0 },
};





Menu::Menu()
{

}

Menu::~Menu()
{

}

void Menu::init()
{
    // set all default game parameters
    _level = 1;
    _FPS = 50;

    //_control = true;
    _colour = true;
    _tone = true;
}

void Menu::main(N5110 &lcd, Gamepad &pad, Visuals &visual)
{
    int selected = 0;

    while(1) {

        pad.leds_off();

        char d = pad.get_direction();

        if ((d == NW) ||
                (d == N)  ||
                (d == NE)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            selected -= 1;
        }

        if ((d == SW) ||
                (d == S)  ||
                (d == SE)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            selected += 1;
        }


        switch (selected) {

            case 1:

                lcd.clear();
                lcd.printString(" LAND OF ", 0, 0);
                lcd.printString(" MYSTIC MAZES ", 0, 1);
                lcd.printString("|Play game|", 0, 3);
                lcd.printString(" Options", 0, 4);
                lcd.printString(" Audio&Visual", 0, 5);
                lcd.refresh();

                // either clicking joystick or pressing A selects function
                if  (pad.check_event(Gamepad::A_PRESSED)) {

                    if (_tone) {
                        pad.tone(500, 0.20);//audio feedback
                    }
                    playGame(lcd, pad, visual, _level, _tone, _FPS);
                    // call the game function
                }

                wait_ms(250);    // 250ms propogation delay

                break;

            case 2:

                lcd.clear();
                lcd.printString(" LAND OF ", 0, 0);
                lcd.printString(" MYSTIC MAZES ", 0, 1);
                lcd.printString(" Play game", 0, 3);
                lcd.printString("|Options|", 0, 4);
                lcd.printString(" Audio&Visual", 0, 5);
                lcd.refresh();

                if  (pad.check_event(Gamepad::A_PRESSED)) {

                    if (_tone) {
                        pad.tone(500, 0.20);//audio feedback
                    }
                    options(lcd, pad, visual, _tone);//call options function when options is selected using pad
                }

                wait_ms(250);    // 250ms propogation delay

                break;

            case 3:

                lcd.clear();
                lcd.printString(" LAND OF ", 0, 0);
                lcd.printString(" MYSTIC MAZES ", 0, 1);
                lcd.printString(" Play game", 0, 3);
                lcd.printString(" Options", 0, 4);
                lcd.printString("|Audio&Visual|", 0, 5);
                lcd.refresh();

                if  (pad.check_event(Gamepad::A_PRESSED)){

                    if (_tone) {
                        pad.tone(500, 0.20);//audio feedback
                    }
                    settings(lcd, pad, visual);//call settings function when settings is selected using pad
                }

                wait_ms(250);    // 250ms propogation delay

                break;

            default:

                selected = 1;

                break;

        }

    }

}

void Menu::intro(N5110 &lcd, Gamepad &pad, Visuals &visual)
{


    printf("intro begun \n");
    while (pad.check_event(Gamepad::START_PRESSED) == false) {

        visual.intro(lcd, pad);
        pad.leds_on();
        wait(0.1);
        pad.leds_off();
        wait(0.1);
    }
}





void Menu::levelOptions(N5110 &lcd, Gamepad &pad)
{
    int selected = 0;
    int exit = 0;
    wait_ms(250);

    while(exit == 0) {

        char d = pad.get_direction();

        if ((d == NW) ||
                (d == N)  ||
                (d == NE)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            selected -= 1;
        }

        if ((d == SW) ||
                (d == S)  ||
                (d == SE)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            selected += 1;
        }

        switch(selected) {

            case 1:

                lcd.clear();
                lcd.printString("Level: ", 0, 0);
                lcd.printString("|Easy|", 0, 2);
                lcd.printString(" Medium", 0, 3);
                lcd.printString(" Hard", 0, 4);
                lcd.refresh();

                wait_ms(250);   // 250ms propogation delay

               if  (pad.check_event(Gamepad::A_PRESSED)) {

                    _level = 1; //set level integer to 1 when easy mode is selected

                    if (_tone) {
                        pad.tone(1000, 0.20);//audio feedback
                    }

                    lcd.clear();
                    lcd.printString("     EASY", 0, 1);
                    lcd.printString("     MODE", 0, 2);
                    lcd.printString("     SELECTED", 0, 3);
                    lcd.refresh();
                    wait(2);

                    exit++;
                }

                break;

            case 2:

                lcd.clear();
                lcd.printString("Level: ", 0, 0);
                lcd.printString(" Easy", 0, 2);
                lcd.printString("|Medium|", 0, 3);
                lcd.printString(" Hard", 0, 4);
                lcd.refresh();

                wait_ms(250);   // 250ms propogation delay

                if  (pad.check_event(Gamepad::A_PRESSED)){

                    _level = 2;//set level integer to 2 when medium mode is selected

                    if (_tone) {
                        pad.tone(1000, 0.20);//audio feedback
                    }

                    lcd.clear();
                    lcd.printString("   MEDIUM", 0, 1);
                    lcd.printString("   MODE", 0, 2);
                    lcd.printString("   SELECTED", 0, 3);
                    lcd.refresh();
                    wait(2);

                    exit++;
                }

                break;

            case 3:

                lcd.clear();
                lcd.printString("Level: ", 0, 0);
                lcd.printString(" Easy", 0, 2);
                lcd.printString(" Medium", 0, 3);
                lcd.printString("|Hard|       ", 0, 4);
                lcd.refresh();

                wait_ms(250);   // 250ms propogation delay

               if  (pad.check_event(Gamepad::A_PRESSED)){

                    _level = 3;//set level integer to 3 when hard mode is selected

                    if (_tone) {
                        pad.tone(1000, 0.20);//audio feedback
                    }

                    lcd.clear();
                    lcd.printString("   HARD", 0, 1);
                    lcd.printString("   MODE", 0, 2);
                    lcd.printString("   SELECTED", 0, 3);
                    lcd.refresh();
                    wait(2);

                    exit++;
                }

                break;

            default:

                selected = 1;

                break;

        }

        if ((pad.check_event(Gamepad::BACK_PRESSED)) ||
                (d == W)) {

            exit++;
        }
    }
}





void Menu::options(N5110 &lcd, Gamepad &pad, Visuals &visual, bool tone)
{
    int exit = 0;
    int selected = 0;
    wait_ms(250);

    while(exit == 0) {

        char d = pad.get_direction();

        if ((d == NW) ||
                (d == N)  ||
                (d == NE)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            selected -= 1;
        }

        if ((d == SW) ||
                (d == S)  ||
                (d == SE)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            selected += 1;
        }
        switch (selected) {


            case 1:

                lcd.clear();
                lcd.printString("Options:", 0, 0);
                lcd.printString("|Level|", 0, 2);
                lcd.printString(" Ball Type", 0, 4);
                lcd.refresh();

                wait_ms(250);


                if  (pad.check_event(Gamepad::A_PRESSED)){

                    if (_tone) {
                        pad.tone(1000, 0.20);//audio feedback
                    }
                    levelOptions(lcd, pad); //call level options function when level is selected
                }

                break;

            case 2:

                lcd.clear();
                lcd.printString("Options:", 0, 0);
                lcd.printString(" Level", 0, 2);
                lcd.printString("|Ball Type|", 0, 4);
                lcd.refresh();

                wait_ms(250);

                if  (pad.check_event(Gamepad::A_PRESSED)){

                    if (_tone) {
                        pad.tone(1000, 0.20);//audio feedback
                    }
                    ballType(lcd, pad, visual); //call ball type funtion when ball type is selected
                }


                break;

            default:

                selected = 1;

                break;
        }

        if ((pad.check_event(Gamepad::BACK_PRESSED)) ||
                (d == W)) {

            exit++;
        }
    }
}


void Menu::ballType(N5110 &lcd, Gamepad &pad, Visuals &visual)
{
    int selected = 0;
    int exit = 0;
    wait_ms(250);

    while(exit == 0) {

        char d = pad.get_direction();

        if ((d == NW) ||
                (d == N)  ||
                (d == NE)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            selected -= 1;
        }

        if ((d == SW) ||
                (d == S)  ||
                (d == SE)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            selected += 1;
        }

        switch(selected) {

            case 1:
                lcd.clear();
                lcd.printString("Ball Type: ", 0, 0);
                lcd.printString("|Bugzy|", 0, 2);
                lcd.printString(" Skepta", 0, 3);
                lcd.refresh();

                wait_ms(250);   // 250ms propogation delay

                if  (pad.check_event(Gamepad::A_PRESSED)){

                    if (_tone) {
                        pad.tone(1000, 0.20);//audio feedback
                    }

                    _colour = true;     // true colour = outline
                    lcd.clear();
                    lcd.printString("   Bugzy is", 0, 1);
                    lcd.printString("   in the", 0, 2);
                    lcd.printString("   GAME", 0, 3);
                    lcd.refresh();
                    wait(2);

                    exit++;
                }


                break;

            case 2:

                lcd.clear();
                lcd.printString("Ball Type: ", 0, 0);
                lcd.printString(" Bugzy", 0, 2);
                lcd.printString("|Skepta|", 0, 3);
                lcd.refresh();

                wait_ms(250);


                if  (pad.check_event(Gamepad::A_PRESSED)){

                    if (_tone) {
                        pad.tone(1000, 0.20);//audio feedback
                    }

                    _colour = false;    // colour = false = fill
                    lcd.clear();
                    lcd.printString("   Skepta is", 0, 1);
                    lcd.printString("   in the", 0, 2);
                    lcd.printString("   GAME", 0, 3);
                    lcd.refresh();
                    wait(2);

                    exit++;
                }

                break;

            default:

                selected = 1;

                break;
        }

        if ((pad.check_event(Gamepad::BACK_PRESSED)) ||
                (d == W)) {

            exit++;
        }
    }


}



void Menu::lcdTheme(N5110 &lcd, Gamepad &pad)
{
    int exit = 0;
    while (exit == 0) {

        lcd.clear();
        lcd.printString("Press L For", 0, 0);
        lcd.printString("Dark theme", 0, 1);
        lcd.printString("Press R For", 0, 4);
        lcd.printString("Light theme", 0, 5);

        if (pad.check_event(Gamepad::L_PRESSED)) {

            lcd.inverseMode();//invert lcd for dark theme
            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }

        }

        if (pad.check_event(Gamepad::R_PRESSED)) {

            lcd.normalMode();//lcd remains normal for light mode

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
        }

        lcd.refresh();

        char d = pad.get_direction();

        if ((pad.check_event(Gamepad::BACK_PRESSED)) ||
                (d == W)) {

            exit++;
        }
    }

}

void Menu::audiosettings(N5110 &lcd, Gamepad &pad, Visuals &visual)
{
    int exit = 0;

    while (exit == 0) {

        char d = pad.get_direction();

        if (d == E) {

            _tone = false;
        }

        if (d == W) {

            _tone = true;
            pad.tone(1000, 0.20);//audio feedback

        }
        lcd.clear();
        lcd.drawRect(33, 27, 17, 9, FILL_TRANSPARENT);

        lcd.printString("Audio Settings", 0, 0);
        lcd.printString("  ON     OFF  ", 0, 2);


        if (_tone) {
            lcd.drawRect(34, 28, 7, 7, FILL_BLACK);
        } else {
            lcd.drawRect(42, 28, 7, 7, FILL_BLACK);
        }

        lcd.refresh();

        wait_ms(10);


        if ((pad.check_event(Gamepad::BACK_PRESSED)) ||
                (pad.check_event(Gamepad::A_PRESSED))) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            exit++;
        }
    }



}


void Menu::gameBrightness(N5110 &lcd, Gamepad &pad, Visuals &visual)
{
    int exit = 0;

    while (exit == 0) {

        lcd.clear();
        lcd.printString("adjust game", 0, 0);
        lcd.printString("brightness", 0, 1);
        lcd.printString("with blue dial", 0, 2);

        double brightness = pad.read_pot(); // returns value between 0.0 - 1.0 which is used to represent lcd brightness

        lcd.setBrightness(brightness);

        lcd.drawRect(10, 30, 41, 8, FILL_TRANSPARENT);
        lcd.drawRect(11, 31, brightness * 40, 6, FILL_BLACK);
        lcd.refresh();


        lcd.refresh();

        wait_ms(5);

        char d = pad.get_direction();

        if ((pad.check_event(Gamepad::BACK_PRESSED)) ||
                (d == W)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            exit++;
        }
    }
}






void Menu::playGame(N5110 &lcd,Gamepad &pad,Visuals &visual,int mazeModel,bool tone,float FPS)
{
    int w = 5;
    double l;
    int v = 5;
    int x;
    int y;
    int radius;


    _mazeModel = mazeModelSelector(_level);

    //set level integer based on selection

    if (_level == 1) {


        x = 8; // place ball in appropriate location for each level
        y = 5;
        radius = 2; // set radius accordingly
    }

    else if (_level == 2) {
        x = 8;
        y = 5;
        radius = 2;
    }

    else if (_level == 3) {
        x = 5;
        y = 3;
        radius = 1;
    }

    //initialise game with correct gaming parameters for selected level

    _mazeEn.init(_mazeModel, x, y,radius, _colour, _control);

    int exit = 0;
    while (exit == 0) {

        w+=2;
        v+=1;


        _mazeEn._finish = false;

        // render screen
        lcd.clear();
        _mazeEn.draw(lcd,visual);


        //medium level contains obstacles
        //if level == 2 (medium), draw sprites
        if (_level == 2) {
            lcd.drawSprite(w,40,12,10,(int *)run);//draw sprite for first obstacle
            lcd.drawSprite(23,v,11,9,(int *)run1);//draw sprite for second obstacle
        }

        if (v>25) {  // if gone past line at y=25 on buffer, screen then move back to top of screen
            v=0;
        }

        if (w>61) {  // if gone past line at x=61 on buffer, move back to left
            wait_ms(500);

            w=0;
        }
        lcd.refresh();

        Vector2D _position1 = _ball.getPosition();

        _mazeEn.readInput(pad);
        _mazeEn.update(lcd);

        wait_ms(250);

        printf("w = %2f\n", l);

        //if loop to end game when ball comes in contact with horizontal moving obstacle in medium maze level
        /*if (_level == 2) {

            if (w == _position1.x) {

                while (_position1.y == 40);
                lcd.clear();
                visual.mazeOver(lcd, pad);
                exit ++;
                }



            //if loop to end game when ball comes in contact with vertical moving obstacle
            else if (_position1.y == v++) {

              while (_position1.x == 22);
                lcd.clear();
                visual.mazeOver(lcd, pad);
                exit ++;
            }
             else if (y == v) {

                while (x != 22);

                exit =0;
            }
            else if (w == x) {

                while (y != 40);
                exit =0;
            }
            else if (w != x) {

                while (y == 40);
                exit =0;
            }
            else if (y != v) {

                while (x == 22);

                exit =0;
            }

            }*/

        if (_mazeEn.checkFinish()) {
            visualMazeEnd(lcd, pad, visual);
            exit ++;
        }


        char d = pad.get_direction();
        if  (pad.check_event(Gamepad::BACK_PRESSED)) {

            exit++;
        }
    }

}






int Menu::mazeModelSelector(int level)
{
    // generates a random number between a pair of values
    // based on the difficulty level chosen

    _level = level;

    if (_level == 1) {

        _mazeModel = 0;
    }

    else if (level == 2) {

        _mazeModel = 1;
    }

    else {

        _mazeModel = 2;
    }

    return _mazeModel;
}




void Menu::visualMazeEnd(N5110 &lcd, Gamepad &pad, Visuals &visual)
{

    lcd.clear();
    visual.mazeExplored(lcd, pad);

}





void Menu::visualGameOver(N5110 &lcd, Gamepad &pad, Visuals &visual)
{

    lcd.clear();
    visual.mazeOver(lcd, pad);

}




//Develop settings screen/interface
void Menu::settings(N5110 &lcd, Gamepad &pad, Visuals &visual)
{
    int exit = 0;
    int selected = 0;
    wait_ms(250);

    while(exit == 0) {

        char d = pad.get_direction();

        if ((d == NW) ||
                (d == N)  ||
                (d == NE)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            selected -= 1;
        }

        if ((d == SW) ||
                (d == S)  ||
                (d == SE)) {

            if (_tone) {
                pad.tone(1000, 0.20);//audio feedback
            }
            selected += 1;
        }

        switch (selected) {

            case 1:

                lcd.clear();
                lcd.printString("Audio&Visual", 0, 0);
                lcd.printString("Settings:", 0, 1);
                lcd.printString(">Brightness", 0, 3);
                lcd.printString(" Theme", 0, 4);
                lcd.printString(" Audio", 0, 5);
                lcd.refresh();

                wait_ms(250);

                if  (pad.check_event(Gamepad::A_PRESSED)) {

                    if (_tone) {
                        pad.tone(1000, 0.20);//audio feedback
                    }
                    gameBrightness(lcd, pad, visual);
                    //printf("brightness selected");
                }

                break;

            case 2:

                lcd.clear();
                // displays options page with indicator on second
                lcd.printString("Audio&Visual", 0, 0);
                lcd.printString("Settings:", 0, 1);
                lcd.printString(" Brightness", 0, 3);
                lcd.printString(">Theme", 0, 4);
                lcd.printString(" Audio", 0, 5);

                lcd.refresh();

                wait_ms(250);

                // if second option selected
                if  (pad.check_event(Gamepad::A_PRESSED)) {

                    if (_tone) {
                        pad.tone(1000, 0.20);//audio feedback
                    }
                    lcdTheme(lcd, pad);
                }

                break;
            case 3:

                lcd.clear();
                lcd.printString("Audio&Visual", 0, 0);
                lcd.printString("Settings:", 0, 1);
                lcd.printString(" Brightness", 0, 3);
                lcd.printString(" Theme", 0, 4);
                lcd.printString(">Audio", 0, 5);
                lcd.refresh();

                wait_ms(250);

                if  (pad.check_event(Gamepad::A_PRESSED)){

                    if (_tone) {
                        pad.tone(1000, 0.20);//audio feedback
                    }
                    audiosettings(lcd, pad, visual);
                }

                break;

            default:

                selected = 1;

                break;
        }

        if ((pad.check_event(Gamepad::BACK_PRESSED)) ||
                (d == W)) {

            exit++;
        }

    }


}

