#include "Visuals.h"


Visuals::Visuals()
{
    
}

Visuals::~Visuals()
{
    
}


//intro function
//animates on lcd until start is pressed
void Visuals::intro(N5110 &lcd, Gamepad &pad)
{
     lcd.clear();
    lcd.printString(" MAZE BALL ",0,1);
    lcd.printString(" Ready? ",0,2.8);
    lcd.printString(" Press Start ",0,4.5);
    lcd.refresh();
 
}


//maze explored function
//animates screen when maze has been completed
void Visuals::mazeExplored(N5110 &lcd, Gamepad &pad)
{
    lcd.printString("  MAZE", 0, 2);
    lcd.printString("  EXPLORED!", 0, 3);
    
    lcd.refresh();
        
        wait_ms(1250);
        
        if (pad.check_event(Gamepad::BACK_PRESSED)){
            
            return;
        }
}


//game over function
//animates screen on the event that the ball collides with object in medium maze level
void Visuals::mazeOver(N5110 &lcd, Gamepad &pad)
{
    lcd.printString("  GAME", 0, 2);
    lcd.printString("  OVER!", 0, 3);
    
    lcd.refresh();
        
        wait_ms(1250);
        
        if (pad.check_event(Gamepad::BACK_PRESSED)){
            
            return;
        }
    
    
    
}

//audio switch funtion
//animates screen when audio settings are selected
//shows switch to select if sound is on or off
void Visuals::audioSwitch(N5110 &lcd, Gamepad &pad, bool tone)
{
 int exit = 0;
    bool _tone = tone;
    
    while(exit == 0){
       lcd.clear();
        
        // draw casing rectangle
        lcd.drawRect(33, 27, 17, 9, FILL_TRANSPARENT);
        
        lcd.printString("Audio Settings", 0, 0);
        lcd.printString("  ON     OFF  ", 0, 2);
        
        // casing rectangle is filled in one side
        // depending on value of _tone
        if (_tone){
            lcd.drawRect(34, 28, 7, 7, FILL_BLACK);
        }
        else {
            lcd.drawRect(42, 28, 7, 7, FILL_BLACK);
        }
        
        lcd.refresh();
        
        wait_ms(10);
        
        if (pad.check_event(Gamepad::BACK_PRESSED)){
            
            return;
        }
    }
 
 
    
}
