/*
ELEC2645 Embedded Systems Project
School of Electronic & Electrical Engineering
University of Leeds
Name:Chukwuebuka Nwibe
Username:el16ccn
Student ID Number:201035766
Date:
*/
#include "mbed.h"
#include "Gamepad.h"
#include "N5110.h"
#include "MazeEngine.h"
#include "Menu.h"
#include "Visuals.h"


#define WITH_TESTING
#ifdef WITH_TESTING
# include "tests.h"
#endif




N5110 lcd(PTC9,PTC0,PTC7,PTD2,PTD1,PTC11);
Visuals visual;
Gamepad pad;
Menu menu;

void init();

int main()
{
#ifdef WITH_TESTING
    int number_of_failures = run_all_tests();

    if(number_of_failures > 0) return number_of_failures;
#endif

    init(); // initialise devices
    printf("Device initialised \n");



    menu.intro(lcd, pad, visual);

    while(1) {

        menu.main(lcd, pad, visual);

    }
}


void init()
{
    menu.init();
    lcd.init();
    pad.init();
    lcd.setContrast(0.5);
}
